Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.xml.serialize.transition
Class HTMLSerializer

    java.lang.Object
      |
      +--org.apache.xml.serialize.transition.BaseMarkupSerializer
            |
            +--org.apache.xml.serialize.transition.HTMLSerializer

Direct Known Subclasses:
  XHTMLSerializer

public class HTMLSerializer
extends BaseMarkupSerializer

Implements an HTML/XHTML serializer supporting both DOM and SAX pretty serializing. HTML/XHTML mode is determined in the constructor. For usage instructions see `Serializer`.

If an output stream is used, the encoding is taken from the output format (defaults to `UTF-8`). If a writer is used, make sure the writer uses the same encoding (if applies) as specified in the output format.

The serializer supports both DOM and SAX. DOM serializing is done by calling `BaseMarkupSerializer.serialize(org.w3c.dom.Element)` and SAX serializing is done by firing SAX events and using the serializer as a document handler.

If an I/O exception occurs while serializing, the serializer will not throw an exception directly, but only throw it at the end of serializing (either DOM or SAX's `DocumentHandler.endDocument()`.

For elements that are not specified as whitespace preserving, the serializer will potentially break long text lines at space boundaries, indent lines, and serialize elements on separate lines. Line terminators will be regarded as spaces, and spaces at beginning of line will be stripped.

XHTML is slightly different than HTML:

- Element/attribute names are lower case and case matters
- Attributes must specify value, even if empty string
- Empty elements must have '/' in empty tag
- Contents of SCRIPT and STYLE elements serialized as CDATA

See Also:
  `Serializer`

Inner Class Summary
`static class` | `HTMLSerializer.DTD`

Field Summary
`static java.lang.String` | `XHTMLNamespace`

Constructor Summary
`HTMLSerializer()` Constructs a new serializer.
`HTMLSerializer(OutputFormat format)` Constructs a new serializer.
`HTMLSerializer(java.io.OutputStream output, OutputFormat format)` Constructs a new serializer that writes to the specified output stream using the specified output format.
`HTMLSerializer(java.io.Writer writer, OutputFormat format)` Constructs a new serializer that writes to the specified writer using the specified output format.

Method Summary
`void` | `characters(char[] chars, int start, int length)`
`void` | `endElement(java.lang.String tagName)`
`void` | `endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName)`
`void` | `setOutputFormat(OutputFormat format)`
`void` | `startElement(java.lang.String tagName, AttributeList attrs)`
`void` | `startElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName, Attributes attrs)`

Methods inherited from class org.apache.xml.serialize.transition.BaseMarkupSerializer
`asContentHandler, asDocumentHandler, asDOMSerializer, attributeDecl, comment, comment, elementDecl, endCDATA, endDocument, endDTD, endEntity, endNonEscaping, endPrefixMapping, endPreserving, externalEntityDecl, getOutputFormat, getOutputStream, getWriter, ignorableWhitespace, internalEntityDecl, notationDecl, processingInstruction, reset, serialize, serialize, serialize, serializeXPathReturnNode, setDocumentLocator, setOutputStream, setWriter, skippedEntity, startCDATA, startDocument, startDTD, startEntity, startNonEscaping, startPrefixMapping, startPreserving, unparsedEntityDecl`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### XHTMLNamespace

    public static java.lang.String XHTMLNamespace

Constructor Detail

### HTMLSerializer

    public HTMLSerializer()

  Constructs a new serializer. The serializer cannot be used without calling `#setOutputCharStream` or `BaseMarkupSerializer.setOutputStream(java.io.OutputStream)` first.

### HTMLSerializer

    public HTMLSerializer(OutputFormat format)

  Constructs a new serializer. The serializer cannot be used without calling `#setOutputCharStream` or `BaseMarkupSerializer.setOutputStream(java.io.OutputStream)` first.

### HTMLSerializer

    public HTMLSerializer(java.io.Writer writer,
                          OutputFormat format)

  Constructs a new serializer that writes to the specified writer using the specified output format. If `format` is null, will use a default output format.
  Parameters:
    `writer` - The writer to use
    `format` - The output format to use, null for the default

### HTMLSerializer

    public HTMLSerializer(java.io.OutputStream output,
                          OutputFormat format)

  Constructs a new serializer that writes to the specified output stream using the specified output format. If `format` is null, will use a default output format.
  Parameters:
    `output` - The output stream to use
    `format` - The output format to use, null for the default

Method Detail

### setOutputFormat

    public void setOutputFormat(OutputFormat format)

  Overrides:
    setOutputFormat in class BaseMarkupSerializer

### startElement

    public void startElement(java.lang.String namespaceURI,
                             java.lang.String localName,
                             java.lang.String rawName,
                             Attributes attrs)

### endElement

    public void endElement(java.lang.String namespaceURI,
                           java.lang.String localName,
                           java.lang.String rawName)

### characters

    public void characters(char[] chars,
                           int start,
                           int length)

  Overrides:
    characters in class BaseMarkupSerializer

### startElement

    public void startElement(java.lang.String tagName,
                             AttributeList attrs)

### endElement

    public void endElement(java.lang.String tagName)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000 Apache XML Project. All Rights Reserved.